%global __provides_exclude_from %{_datadir}/doc/.*
%global __requires_exclude_from %{_datadir}/doc/.*
%define	module	matplotlib
%define	basepy3dir	%(echo ../`basename %{py3dir}`)
%define with_html 0
# we don't want to provide private python extension libs
%define _exclude_files_from_autoprov %{python_sitearch}/.*\\.so\\|%{python3_sitearch}/.*\\.so

# the default backend; one of GTK GTKAgg GTKCairo GTK3Agg GTK3Cairo
# CocoaAgg MacOSX Qt4Agg TkAgg WX WXAgg Agg Cairo GDK PS PDF SVG
%global backend                 TkAgg
#%%global backend                 Qt4Agg
%global with_bundled_fonts      1

Name:		python-%{module}
Version:	1.4.3
Release:	%mkrel 2
Summary:	Matlab-style 2D plotting package for Python
Group:		Development/Python
License:	Python license
URL:		http://matplotlib.org/
Source0:	https://downloads.sourceforge.net/project/%{module}/%{module}/%{module}-%{version}/%{module}-%{version}.tar.xz
Source1:        setup.cfg

Patch0:         %{name}-noagg.patch
#Patch1:         %{name}-system-cxx.patch
#Patch2:         20_matplotlibrc_path_search_fix.patch
Patch3:         40_bts608939_draw_markers_description.patch
Patch4:         50_bts608942_spaces_in_param_args.patch
#Patch5:         60_deal_with_no_writable_dirs.patch
Patch6:         70_bts720549_try_StayPuft_for_xkcd.patch


BuildRequires:	python-setuptools
BuildRequires:	python-numpy-devel >= 1.1.0
BuildRequires:	libwxPythonGTK-devel
BuildRequires:	pygtk2.0-devel
BuildRequires:	cairo-devel
BuildRequires:	tkinter
BuildRequires:	tcl-devel
BuildRequires:	tk-devel
BuildRequires:	freetype2-devel >= 2.1.7
BuildRequires:	python-qt4
BuildRequires:	python-qt4-devel
BuildRequires:	python-qt5
BuildRequires:	python-qt5-devel
BuildRequires:	agg-devel
BuildRequires:	libpng-devel
BuildRequires:	zlib-devel 
BuildRequires:	python-configobj
BuildRequires:	python-dateutil
BuildRequires:	python-pytz
BuildRequires:	python-docutils
BuildRequires:	python-sphinx
BuildRequires:	ipython
BuildRequires:	python-six
BuildRequires:	python-gobject3-devel
BuildRequires:	pyside
BuildRequires:  gtk+3-devel
BuildRequires:  python-gi
BuildRequires:  python-gi-cairo
#BuildRequires:  python3-pyxdg

%if %{with_html}
BuildRequires:  python-numpydoc
%endif
Obsoletes:  %{name}-emf 
Obsoletes:  %{name}-fltk 
Requires:   python-numpy >= 1.1.0
Requires:   python-configobj
Requires:   python-dateutil
Requires:   python-pytz
Requires:   python-parsing
Requires:   python-gi
Requires:   fonts-ttf-bitstream-vera

# GTKAgg does not require extra subpackages, but does not work with python3
%if "%{backend}" == "TkAgg"
Requires:       %{name}-tk%{?_isa} = %{version}-%{release}
%else
%if "%{backend}" == "Qt4Agg"
Requires:       %{name}-qt4%{?_isa} = %{version}-%{release}
%endif
%endif

%description
matplotlib is a Python 2D plotting library which produces publication
quality figures in a variety of hardcopy formats and interactive
environments across platforms. matplotlib can be used in Python
scripts, the python and ipython shell (a la Matlab or Mathematica), web
application servers, and various graphical user interface toolkits.

%package cairo
Summary:	Cairo backend for matplotlib
Group:		Development/Python
Requires:	%{name} = %{version}-%{release}
Requires:	python-cairo >= 1.2.0

%description cairo
This package contains the Cairo backend for matplotlib.

%package gtk
Summary:	GDK and GTK backends for matplotlib
Group:		Development/Python
Requires:	%{name} = %{version}-%{release}
Requires:	pygtk2.0 >= 2.4.0
Requires:	%{name}-cairo = %{version}-%{release}

%description gtk
This package contains the GDK and GTK backends for matplotlib.

%package gtk3
Summary:	GTK3 backends for matplotlib
Group:		Development/Python
Requires:	%{name} = %{version}-%{release}
Requires:	%{name}-cairo = %{version}-%{release}

%description gtk3
This package contains the GDK3 backends for matplotlib.

%package qt4
Summary:	Qt4 backend for matplotlib
Group:		Development/Python
Requires:	%{name} = %{version}-%{release}
Requires:   %{name}-qt-shared = %{version}-%{release}
Requires:	python-qt4

%description qt4
This package contains the Qt4 backend for matplotlib.

%package qt5
Summary:	Qt5 backend for matplotlib
Group:		Development/Python
Requires:	%{name} = %{version}-%{release}
Requires:   %{name}-qt-shared = %{version}-%{release}
Requires:	python-qt5

%description qt5
This package contains the Qt5 backend for matplotlib.

%package qt-shared
Summary:    Shared files for the Qt backends for matplotlib
Group:      Development/Python
Requires:   %{name} = %{version}-%{release}
Requires:   python-qt5

%description qt-shared
This package includes files needed by both the Qt4-based pyqt4 and 
pyside backends and the Qt5-based pyqt5 backend for the matplotlib
plotting package

%package svg
Summary:	SVG backend for matplotlib
Group:		Development/Python
Requires:	%{name} = %{version}-%{release}

%description svg
This package contains the SVG backend for matplotlib.

%package pgf
Summary:	PGF backend for matplotlib
Group:		Development/Python
Requires:	%{name} = %{version}-%{release}

%description pgf
This package contains the PGF backend for matplotlib.

%package tk
Summary:	Tk backend for matplotlib
Group:		Development/Python
Requires:	%{name} = %{version}-%{release}
Requires:	tkinter

%description tk
This package contains the Tk backend for matplotlib.

%package wx
Summary:	wxPython backend for matplotlib
Group:		Development/Python
Requires:	%{name} = %{version}-%{release}
Requires:	wxPython

%description wx
This package contains the wxPython backend for matplotlib.

%package doc
Summary:	Documentation for matplotlib
Group:		Development/Python
BuildArch: noarch

%description doc
This package contains documentation and sample code for matplotlib.

%package -n	python3-matplotlib
Summary:	Python 2D plotting library
Group:		Development/Python
BuildRequires:	python3-setuptools
BuildRequires:	python3-cairo
BuildRequires:	python3-dateutil
BuildRequires:	pkgconfig(python3)
BuildRequires:	python3-gobject3
BuildRequires:	python3-numpy-devel
BuildRequires:	python3-parsing
BuildRequires:	python3-pytz
BuildRequires:	python3-six
BuildRequires:	python3-qt5
BuildRequires:	python3-qt4
BuildRequires:	python3-sip-devel
BuildRequires:	python3-pyside
# Try to build without xvfb-run to see if it solve the dbus problem
#BuildRequires:	x11-server-xvfb
Requires:	python3-gobject3
Requires:	python3-numpy
Requires:	python3-cairo
Requires:	python3-parsing
Requires:	python3-dateutil
Requires:	python3-pytz
Requires:       fonts-ttf-bitstream-vera
%if "%{backend}" == "TkAgg"
Requires:       python3-matplotlib-tk%{?_isa} = %{version}-%{release}
%else
%if "%{backend}" == "Qt4Agg"
Requires:       python3-matplotlib-qt4%{?_isa} = %{version}-%{release}
%endif
%endif

%description -n	python3-matplotlib
Matplotlib is a python 2D plotting library which produces publication
quality figures in a variety of hardcopy formats and interactive
environments across platforms. matplotlib can be used in python
scripts, the python and ipython shell, web application servers, and
six graphical user interface toolkits.

Matplotlib tries to make easy things easy and hard things possible.
You can generate plots, histograms, power spectra, bar charts,
errorcharts, scatterplots, etc, with just a few lines of code.

%package -n	python3-matplotlib-qt4
Summary:	Qt4 backend for python3-matplotlib
Group:		Development/Python
Requires:	%{name}%{?_isa} = %{version}-%{release}
Requires:	python3-qt4

%description -n	python3-matplotlib-qt4
%{summary}

%package -n	python3-matplotlib-tk
Summary:	Tk backend for python3-matplotlib
Group:		Development/Python
Requires:	python3-matplotlib%{?_isa} = %{version}-%{release}
BuildRequires:	tkinter3
Requires:	tkinter3

%description -n	python3-matplotlib-tk
%{summary}

%prep
%setup -q -n %{module}-%{version}
# Copy setup.cfg to the builddir
cp %{SOURCE1} .
sed -i 's/\(backend = \).*/\1%{backend}/' setup.cfg


%if !%{with_bundled_fonts}
# Use fontconfig by default
sed -i 's/\(USE_FONTCONFIG = \)False/\1True/' lib/matplotlib/font_manager.py
%endif

# Remove bundled libraries
rm -rf  CXX

# Remove references to bundled libraries
%patch0 -b .noagg
#%%patch1 -b .cxx
#patch2 -p1
%patch3 -p1
%patch4 -p1
#patch5 -p1
%patch6 -p1

chmod -x lib/matplotlib/mpl-data/images/*.svg
rm -rf %{py3dir}
cp -a . %{py3dir}

%build
find -name .svn | xargs rm -rf

#gws ???
export XDG_RUNTIME_DIR=$TMP

# Remove duplicate test data file:
%__rm -f lib/matplotlib/tests/baseline_images/test_axes/shaped\ data.svg
MPLCONFIGDIR=$PWD \
MATPLOTLIBDATA=$PWD/lib/matplotlib/mpl-data \
CFLAGS="%{optflags}" \
  %{__python} setup.py build


%if %{with_html}
# Need to make built matplotlib libs available for the sphinx extensions:
pushd doc
    export PYTHONPATH=`realpath ../build/lib.linux*`
    %{__python} make.py html
popd
%endif

pushd %{py3dir}
find -name .svn | xargs rm -rf
# Remove duplicate test data file:
%__rm -f lib/matplotlib/tests/baseline_images/test_axes/shaped\ data.svg
MPLCONFIGDIR=$PWD \
MATPLOTLIBDATA=$PWD/lib/matplotlib/mpl-data \
CFLAGS="%{optflags}" \
  %{__python3} setup.py build
popd


%install
pushd %{py3dir}
    %{__python3} setup.py install -O1 --skip-build --root=%{buildroot}
    chmod +x $RPM_BUILD_ROOT%{python3_sitearch}/matplotlib/dates.py
    rm -rf $RPM_BUILD_ROOT%{python3_sitearch}/matplotlib/mpl-data/fonts
    rm -f $RPM_BUILD_ROOT%{python3_sitearch}/six.py
popd

%{__python} setup.py install -O1 --skip-build --root=%{buildroot}

%files
%{py_platsitedir}/%{module}/*.py*
%{py_platsitedir}/%{module}/*.so
%{py_platsitedir}/%{module}*egg-info
%{py_platsitedir}/%{module}-*-nspkg.pth
%{py_platsitedir}/%{module}/backends/Matplotlib.nib*
%{py_platsitedir}/%{module}/backends/__init__*
%{py_platsitedir}/%{module}/backends/*backend_agg*
%{py_platsitedir}/%{module}/backends/backend_cocoa*
%{py_platsitedir}/%{module}/backends/backend_macosx*
%{py_platsitedir}/%{module}/backends/backend_mixed*
%{py_platsitedir}/%{module}/backends/backend_pdf*
%{py_platsitedir}/%{module}/backends/backend_ps*
%{py_platsitedir}/%{module}/backends/backend_template*
%{py_platsitedir}/%{module}/backends/windowing*
%{py_platsitedir}/%{module}/backends/web_backend*
%{py_platsitedir}/%{module}/backends/backend_webagg*
%{py_platsitedir}/%{module}/delaunay*
%{py_platsitedir}/%{module}/mpl-data/*
%{py_platsitedir}/%{module}/projections*
%{py_platsitedir}/%{module}/sphinxext*
%{py_platsitedir}/%{module}/test*
%{py_platsitedir}/%{module}/tri*
%{py_platsitedir}/%{module}/compat*
%{py_platsitedir}/mpl_toolkits*
%{py_platsitedir}/pylab*
#%%{py_platsitedir}/freetype2.so
%{py_platsitedir}/%{module}/axes/
%{py_platsitedir}/%{module}/backends/backend_nbagg*
%{py_platsitedir}/%{module}/style/

%files cairo
%{py_platsitedir}/%{module}/backends/backend_cairo.py*

%files gtk
%{py_platsitedir}/%{module}/backends/backend_gdk.py*
%{py_platsitedir}/%{module}/backends/backend_gtk.py*
%{py_platsitedir}/%{module}/backends/backend_gtkagg.py*
%{py_platsitedir}/%{module}/backends/backend_gtkcairo.py*
%{py_platsitedir}/%{module}/backends/_backend_gdk.so
%{py_platsitedir}/%{module}/backends/_gtkagg.so

%files gtk3
%{py_platsitedir}/%{module}/backends/backend_gtk3.py*
%{py_platsitedir}/%{module}/backends/backend_gtk3agg.py*
%{py_platsitedir}/%{module}/backends/backend_gtk3cairo.py*

%files qt4
%{py_platsitedir}/%{module}/backends/backend_qt4.py*
%{py_platsitedir}/%{module}/backends/backend_qt4agg.py*

%files qt-shared
# IMPORTANT: the qt4 backend makes use of the qt5 backend, 
# which is actually a generic qt backend.
# So we need to package all the qt5 stuff in this generic
# package, and provide a stub package which pulls in the 
# python-qt5 dependency.
%{python_sitearch}/%{module}/backends/backend_qt5.*
%{python_sitearch}/%{module}/backends/backend_qt5agg.*
%{python_sitearch}/%{module}/backends/qt_compat.*
%{python_sitearch}/%{module}/backends/qt4_compat.*
%{python_sitearch}/%{module}/backends/qt_editor/

%files qt5
# IMPORTANT: the qt4 backend makes use of the qt5 backend, 
# which is actually a generic qt backend.
# So we need to package all the qt5 stuff in a generic
# package, and provide this stub package which pulls in the 
# python-qt5 dependency.
%doc README.rst

%files pgf
%{py_platsitedir}/%{module}/backends/backend_pgf.py*

%files svg
%{py_platsitedir}/%{module}/backends/backend_svg.py*

%files tk
%{py_platsitedir}/%{module}/backends/backend_tkagg.py*
%{py_platsitedir}/%{module}/backends/tkagg.py*
%{py_platsitedir}/%{module}/backends/_tkagg.so

%files wx
%{py_platsitedir}/%{module}/backends/backend_wx.py*
%{py_platsitedir}/%{module}/backends/backend_wxagg.py*

%files doc
%doc examples/  
%if %{with_html}
%doc doc/build/html/*
%endif

%files -n python3-matplotlib
%{python3_sitearch}/*egg-info
%{python3_sitearch}/matplotlib/
%{python3_sitearch}/mpl_toolkits/
%{python3_sitearch}/pylab.py*
#%%{python3_sitearch}/__pycache__/
#%%{python3_sitearch}/freetype2.cpython-??m.so
%{python3_sitearch}/%{module}-*-nspkg.pth
%exclude %{python3_sitearch}/matplotlib/backends/backend_qt4.*
%exclude %{python3_sitearch}/matplotlib/backends/backend_qt4agg.*
%exclude %{python3_sitearch}/matplotlib/backends/backend_tkagg.*
%exclude %{python3_sitearch}/matplotlib/backends/tkagg.*
%exclude %{python3_sitearch}/matplotlib/backends/_tkagg.*

%files -n python3-matplotlib-qt4
%{python3_sitearch}/matplotlib/backends/backend_qt4.*
%{python3_sitearch}/matplotlib/backends/backend_qt4agg.*

%files -n python3-matplotlib-tk
%{python3_sitearch}/matplotlib/backends/backend_tkagg.py*
%{python3_sitearch}/matplotlib/backends/tkagg.*
%{python3_sitearch}/matplotlib/backends/_tkagg.*


%changelog
* Tue Aug 15 2017 bb2 <bb2> - 1.4.3-2pclos2017
- rebuild against updates

* Fri Jun 26 2015 gseaman <galen.seaman at comcast.net> 1.4.3-1gseaman2015
- rebase for PCLinuxOS from Mageia spec
